int N = 10000; 
float D = 20.0;
int TMAX = 40; //ttl max d'une particule en frames

// valeurs RGB corps noir pour une temp de 1000 a 10000K avec un pas de 500K
float[] kelvinR = {1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,0.907,0.827,0.762,0.711,0.668,0.632,0.602};
float[] kelvinG = {0.007,0.126,0.234,0.349,0.454,0.549,0.635,0.710,0.778,0.837,0.890,0.937,0.888,0.839,0.800,0.766,0.738,0.714,0.693};
float[] kelvinB = {0.000,0.000,0.010,0.067,0.151,0.254,0.370,0.493,0.620,0.746,0.869,0.988,1.000,1.000,1.000,1.000,1.000,1.000,1.000};


int[] x = new int[N];
int[] y = new int[N];
int[] ttl = new int[N];
int[] dx = new int[N];
int[] dy = new int[N];

int i;
float th,ra,a;
int g = 1; //gravite

void setup(){
  size(600,600);
 // frameRate(10);
 strokeWeight(2);
  colorMode(RGB,1.0);
  noStroke();
  for (i=0;i<N;i++) {
  // init des positions
    th = 2*PI*random(1.0);
    ra = sqrt(-2*log(random(1.0)));
    x[i] = 300+int(D*ra*cos(th));
    y[i] = 300+int(D*ra*sin(th));
  // init des angles de tir
    dx[i] = int(random(-5,5));
    dy[i] = int(random(5,20));
  // init des durees de vie
    ttl[i] = int(random(20, TMAX));
  }

}

void draw(){
 // dessin des particules
 background(0,0,0);
 
 for (i=0;i<N;i++) {
   if (ttl[i]>0){
    fillCorpsNoir(ttl[i]);
    rect(x[i],height-y[i],3,3);
   }
   else {
       // init des positions
    th = 2*PI*random(1.0);
    ra = sqrt(-2*log(random(1.0)));
    x[i] = mouseX+int(D*ra*cos(th));
    y[i] = height-mouseY+int(D*ra*sin(th));
  // init des angles de tir
    dx[i] = int(random(-5,5));
    dy[i] = int(random(5,20));
  // init des durees de vie
    ttl[i] = int(random(20, TMAX));
   }
 } 
 // nouvelles positions
 for (i=0;i<N;i++) {
  dy[i] -= g;
  x[i] += dx[i];
  y[i] += dy[i];
  ttl[i] --;
 }
}

void strokeCorpsNoir(int t){
  int temp = int(19*float(t)/TMAX);
  stroke(kelvinR[temp],kelvinG[temp],kelvinB[temp]);
}

void fillCorpsNoir(int t){
  int temp = int(19*float(t)/TMAX);
  fill(kelvinR[temp],kelvinG[temp],kelvinB[temp],0.5);
}
